image: ubuntu:20.04

stages:
#    -   lint
    -   test
    -   release

variables:
    PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache"

#cache:
#    paths:
#        - .cache/pip
#        - venv/
#        -   data/PFASDR.Data.15-node-dynsim-benchmark/

#lint-pur-venv:
#    image: python:3.8-slim
#    script:
#        -   exit 0  # TODO
#        -   python3.8 -m venv venv
#        -   venv/bin/python3.8 -m pip install --quiet --upgrade -r requirements.d/venv.txt
#        -   sed -i "/zipp==/c\zipp==3.1.0" requirements.d/venv.txt; venv/bin/python3.8 -m pur --nonzero-exit-code -r requirements.d/venv.txt; rc=$?; echo $rc; if [ $rc -eq 11 ]; then echo $rc; sed -i "/zipp==/c\zipp==1.2.0" requirements.d/venv.txt; cat requirements.d/venv.txt; git commit -m 'Update requirements - done by pur' requirements.d/venv.txt; git push; fi;
#    stage: lint

#lint-pur-base:
#    image: python:3.8-slim
#    script:
#        -   exit 0  # TODO
#        -   python3.8 -m venv venv
#        -   venv/bin/python3.8 -m pip install --quiet --upgrade -r requirements.d/venv.txt
#        -   sed -i "/zipp==/c\zipp==3.1.0" requirements.d/base.txt; venv/bin/python3.8 -m pur --nonzero-exit-code -r requirements.d/base.txt; rc=$?; echo $rc; if [ $rc -eq 11 ]; then echo $rc; sed -i "/zipp==/c\zipp==1.2.0" requirements.d/base.txt; cat requirements.d/base.txt; git commit -m 'Update requirements - done by pur' requirements.d/base.txt; git push; fi;
#        -   echo requirements.d/base.txt
#    stage: lint

test-cli-pypy36:
#    cache:
#        key:
#            pypy36
    image: pypy:3.6-7.3.0-slim
    script:
        -   pypy3 -m venv venv
        -   venv/bin/pypy3 -m pip install --quiet --upgrade -r requirements.d/venv.txt
        -   venv/bin/pypy3 -m tox -e cli-pypy36
    stage: test

test-cli-py36:
#    cache:
#        key:
#            py36
    image: python:3.6.10-slim
    script:
        -   python3.6 -m venv venv
        -   venv/bin/python3.6 -m pip install --quiet --upgrade -r requirements.d/venv.txt
        -   venv/bin/python3.6 -m tox -e cli-py36
    stage: test

test-cli-py37:
#    cache:
#        key:
#            py37
    image: python:3.7.7-slim
    script:
        -   python3.7 -m venv venv
        -   venv/bin/python3.7 -m pip install --quiet --upgrade -r requirements.d/venv.txt
        -   venv/bin/python3.7 -m tox -e cli-py37
    stage: test

test-cli-py38:
#    cache:
#        key:
#            py38
    image: python:3.8.2-slim
    script:
        -   python3.8 -m venv venv
        -   venv/bin/python3.8 -m pip install --quiet --upgrade -r requirements.d/venv.txt
        -   venv/bin/python3.8 -m tox -e cli-py38
    stage: test

test-cli-py39:
#    cache:
#        key:
#            py39
    image: python:3.9.1-slim
    script:
        -   python3.9 -m venv venv
        -   venv/bin/python3.9 -m pip install --quiet --upgrade -r requirements.d/venv.txt
        -   venv/bin/python3.9 -m tox -e cli-py39
    stage: test

# test-neural-py36:
# Pandas does no longer support Python 3.6

test-neural-py37:
#    cache:
#        key:
#            py37
    image: registry.gitlab.com/pfasdr/mesa/pfasdr_mesa_baseimage:python3.7-rocm-latest
    retry: 2
    script:
        -   python3.7 -m venv venv
        -   venv/bin/python3.7 -m pip install --quiet --upgrade -r requirements.d/venv.txt
        -   venv/bin/python3.7 -m tox -e neural-py37 --notest || true
        -   .tox/neural-py37/bin/python3.7 -m pip install wheel
        -   .tox/neural-py37/bin/python3.7 -m pip install tensorflow-rocm==2.4.0
        -   venv/bin/python3.7 -m tox -e neural-py37
    stage: test

test-neural-py38:
#    cache:
#        key:
#            py38
    image: registry.gitlab.com/pfasdr/mesa/pfasdr_mesa_baseimage:python3.8-rocm-latest
    retry: 2
    script:
        -   python3.8 -m venv venv
        -   venv/bin/python3.8 -m pip install --quiet --upgrade -r requirements.d/venv.txt
        -   venv/bin/python3.8 -m tox -e neural-py38 --notest || true
        -   .tox/neural-py38/bin/python3.8 -m pip install wheel
        -   .tox/neural-py38/bin/python3.8 -m pip install tensorflow-rocm==2.4.0
        -   venv/bin/python3.8 -m tox -e neural-py38
    stage: test

# test-neural-py39:
# TensorFlow does not support Python 3.9, so neither does TensorFlow ROCm

wheel:
    cache:
        key:
            py38
    image: python:3.8.2-slim
    artifacts:
        paths:
            -   dist/*.whl
    script:
        -   apt update
        -   apt install --yes --quiet --quiet --no-install-recommends
            git
        -   python3.8 -m venv venv
        -   venv/bin/python3.8 -m pip install --quiet --upgrade -r requirements.d/venv.txt
        -   venv/bin/python3.8 setup.py bdist_wheel
    stage: release

docker:
    image: docker:stable
    retry: 2
    services:
        -   docker:dind
    script:
        -   docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com &&
            docker build --tag registry.gitlab.com/pfasdr/code/decoder:latest . &&
            docker push registry.gitlab.com/pfasdr/code/decoder:latest
    stage: release
